/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XDisplay.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak
//
// Erstelldatum:	23.08.2000
// letzte Aenderung:15.03.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Ein Objekt der Klasse XDisplay verkoerpert das Ausgabemedium. Es
//					verwaltet zum einen das DirectX-Objekt, zum anderen die Primary
//					und Backbuffer Surfaces. Da die Klasse von XSurface erbt, koennen
//					ihre Objekte ueberall dort uebergeben werden, wo eine XSurface
//					erwartet wird.
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

#define DIRECTDRAW_VERSION 0x0700 // Dann klappts auch mit dem "DirectX>7-SDK"-Nachbarn

#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XDISPLAY_H
#define _XDISPLAY_H

#define D3D_OVERLOADS

// includes
#include <windows.h>
#include <ddraw.h>
#include <d3d.h>

// XGame-includes
#include "XSurface.h"
#include "XLogging.h"

// Klassen-Deklaration

class	XDisplay:	public XSurface
{
public:
	static DWORD	m_dwMaskRed;
	static DWORD	m_dwMaskGreen;
	static DWORD	m_dwMaskBlue;
	
	XDisplay(void);
	virtual ~XDisplay(void);
	
	virtual HRESULT initialize(DWORD	dwWidth,
							   DWORD	dwHeight,
							   DWORD	dwBitsPerPixel,
							   HWND		hWnd,
							   DWORD	dwFlags		= DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN,
							   bool		b3DNeeded	= false);

	virtual HRESULT uninitialize(void);

	HRESULT flip(DWORD	dwFlags = DDFLIP_WAIT);

	virtual HRESULT restore(void);
	
	virtual void setClippingRect(LPRECT	lpClippingRect);

	static DWORD convertRGBToColorModel(WORD	wRed,
										WORD	wGreen,
										WORD	wBlue);

	// friends deklarieren
	friend class XSurface;

	#if defined(XDEBUG) || defined(XFONTDEBUG)
	friend class XFont;
	#endif
	#if defined(XDEBUG) || defined(XSPRITEDEBUG)
	friend class XSprite;
	#endif

protected:
	virtual void resetData(void);

private:
	LPDIRECTDRAWSURFACE7	m_lpPrimarySurface;
	LPDIRECTDRAW7			m_lpDirectDraw7;
	LPDIRECT3D7				m_lpDirect3D7;
	LPDIRECT3DDEVICE7		m_lpDirect3DDevice7;
};

#endif//_XDISPLAY_H

class	XDisplay;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XDisplay.h
/////////////////////////////////////////////////////////////////////////////////////