/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XFrameCounter.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak (pHreak@x-treme-online.de)
//
// Erstelldatum:	16.03.2001
// letzte Aenderung:16.03.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Die Klasse XFrameCounter repraesentiert einen FPS-Zaehler. Die
//					blit-Methode muss pro Frame GENAU EINMAL aufgerufen werden.
//					Mit setText() kann ein Ausgabetext angegeben werden, in dem $f<n>
//					durch den FPS-Wert ersetzt wird. n bestimmt die Anzahl Ziffern,
//					die dabei Verwendung finden (2 <= n <= 9).
//					Bsp.: "fps $f3" fuehrt zu dieser Ausgabe: "fps 025"
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XFRAMECOUNTER_H
#define _XFRAMECOUNTER_H

// includes
#include <windows.h>
#include <stdio.h>

// XGame-includes
#include "XFont.h"
#include "XLogging.h"

// Klassen-Deklaration

class	XFrameCounter
{
public:
	XFrameCounter();
	virtual ~XFrameCounter();

	virtual HRESULT uninitialize(void);

	HRESULT setText(char	*pcText);
	HRESULT setFont(XFont	*pxfFont);

	HRESULT	blit(XSurface	*pDestinationXSurface,
				 DWORD		dwFlags	= DDBLT_KEYSRC|DDBLT_WAIT);

	long			m_lX;
	long			m_lY;

protected:
	virtual void resetData(void);

private:
	unsigned long	m_ulFramesPerSecond;
	DWORD			m_dwLastTicks;

	XFont			*m_pxfFont;
	char			*m_pcText;
	char			m_cStringOut[255];
};

#endif//_XFRAMECOUNTER_H

class	XFrameCounter;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XFrameCounter.h
/////////////////////////////////////////////////////////////////////////////////////