/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XMsgSocket.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Ingo Griebsch
//
// Erstelldatum:	08.01.2001
// letzte nderung:	08.01.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000 by x-treme
/////////////////////////////////////////////////////////////////////////////////////


// XGame-Includes
#include "XMsgSocket.h"


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XMsgSocket::XMsgSocket
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XMsgSocket::XMsgSocket()
{

}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XMsgSocket::~XMsgSocket
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Destruktor
/////////////////////////////////////////////////////////////////////////////////////

XMsgSocket::~XMsgSocket()
{

}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XMsgSocket::select
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XMsgSocket::select(HWND hWnd, unsigned int uiMessage, long lEvent)
{
	HRESULT hResult;

	hResult = WSAAsyncSelect(m_Socket, hWnd, uiMessage, lEvent);

	if(hResult == SOCKET_ERROR)
	{
		hResult = WSAGetLastError();

		#if defined (XDEBUG) || defined (XMSGSOCKET)
		XLogging::log("XMsgSocket::select > (FEHLER!!!) WSAAsyncSelect() - Fehler-Nr.: ");
		XLogging::log(hResult);
		XLogging::log("\n");
		#endif

		return hResult;
	}

	#if defined (XDEBUG) || defined (XMSGSOCKET)
	XLogging::log("XMsgSocket::select > erfolgreich\n");
	#endif

	return XSOCKET_OK;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XMsgSocket::selectCancel
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XMsgSocket::selectCancel(HWND hWnd)
{
	HRESULT hResult;

	hResult = WSAAsyncSelect(m_Socket, hWnd, 0, 0);

	if(hResult == SOCKET_ERROR)
	{
		hResult = WSAGetLastError();

		#if defined (XDEBUG) || defined (XMSGSOCKET)
		XLogging::log("XMsgSocket::selectCancel > (FEHLER!!!) WSAAsyncSelect() - Fehler-Nr.: ");
		XLogging::log(hResult);
		XLogging::log("\n");
		#endif

		return hResult;
	}

	#if defined (XDEBUG) || defined (XMSGSOCKET)
	XLogging::log("XMsgSocket::selectCancel > erfolgreich\n");
	#endif

	return XSOCKET_OK;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XMsgSocket::socketProc
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XMsgSocket::socketProc(WORD &dwEvent, WORD &dwError, UINT message, WPARAM wParam, LPARAM lParam)
{
	// eine unserer Nachrichten
	if(message == XSOCKET)
	{
		// unser Socket ?
		if(wParam == m_Socket)
		{
			// Event konvertieren
			dwEvent = (WSAGETSELECTEVENT(lParam));

			// Fehler konvertieren
			dwError = (WSAGETSELECTERROR(lParam));

			// und raus
			return XSOCKET_OK;
		}

		// nicht unser Socket
		else
		{
			return XSOCKET_ERROR;
		}
	}
	
	// keine unserer Nachrichten
	else
	{
		return XSOCKET_ERROR;	
	}


}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XMsgSocket::getHostByAddress
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XMsgSocket::getHostByAddress(HANDLE handle, HOSTENT *&hostent, int nHostentLength, LPSTR lpAddress, int nAddressLength, int nAddressType, HWND hWnd, UINT uiMessage)
{
	HRESULT hResult;
	unsigned long ulAddress;

	// zuerst String wandeln
	ulAddress = inet_addr(lpAddress);
	
	// keine gueltige addresse ?
	if(ulAddress == INADDR_NONE)
	{
		#if defined (XDEBUG) || defined (XSOCKET)
		XLogging::log("XMsgSocket::getHostByAddress > (FEHLER!!!) keine gueltige Adresse\n");
		#endif

		return XSOCKET_ERROR;
	}

	// informationen holen
	hostent = gethostbyaddr((LPSTR) &ulAddress, nAddressLength, nAddressType);

	// keine infos bekommen ?
	if(hostent == 0)
	{
		hResult = WSAGetLastError();
		
		#if defined (XDEBUG) || defined (XSOCKET)
		XLogging::log("XMsgSocket::getHostByAddress > (FEHLER!!!) gethostbyaddr() - Fehler-Nr.: ");
		XLogging::log(hResult);
		XLogging::log("\n");
		#endif

		return hResult;
	}

	#if defined (XDEBUG) || defined (XSOCKET)
	XLogging::log("XMsgSocket::getHostByAddress > erfolgreich\n");
	#endif

	return XSOCKET_OK;
}


  
/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XMsgSocket.cpp
/////////////////////////////////////////////////////////////////////////////////////
